unit u_menu_contas;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  LCLType, ComCtrls, Menus, StdCtrls, CodyCtrls, DBCtrls,
  u_dm_movimentos, u_edita_Facturas,
  u_edita_cgd_movimentos,
  u_edita_cc_nb_movimentos,
  LCLIntf, ShellCtrls, LazFileUtils;

type
  { Tfrm_Menu_Contas }

  Tfrm_Menu_Contas = class(TForm)
    E_Last_Selection: TEdit;
    IL_1_TV_Menu: TImageList;
    IL_2_TV_Menu: TImageList;
    L_Last_Selection: TLabel;
    M_Acerca: TMemo;
    TV_Menu: TTreeView;

    procedure CTV_MenuClick(Sender: TObject);
    procedure CTV_MenuSelectionChanged(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure M_AcercaClick(Sender: TObject);
    procedure TV_MenuClick(Sender: TObject);
    procedure TV_MenuSelectionChanged(Sender: TObject);

  private

  public
//    function GetNodeByText(Tree_Menu: TTreeview; Texto: string): TTreenode;     //https://www.thoughtco.com/locate-treeview-node-by-text-4077859
  end;

const
  ImgIndexChecked = 0;
  ImgIndexUnchecked = 1;

var
  frm_Menu_Contas: Tfrm_Menu_Contas;
  TV_Menu_Build: Boolean = TRUE;
  Ja_Criou: Integer = 0;
implementation

{$R *.frm}

{ Tfrm_Menu_Conta }


// -------------------------------------------------------------------------------------------
function GetNodeByText(Tree_Menu: TTreeview; Texto: string): TTreenode;
var
  CurrentNode : TTreenode;
begin
//https://www.developpez.net/forums/d256699/environnements-developpement/delphi/ttreeview-se-positionner-noeud-dont-on-connait-propriete-text/
  Result := nil;
  CurrentNode := Tree_Menu.Items.GetFirstNode;
  while CurrentNode <> nil do
  begin
    if CurrentNode.Text = Texto then
    begin
      Result := CurrentNode;
      exit;
    end;
    CurrentNode := CurrentNode.GetNext;
  end;
end;

// -------------------------------------------------------------------------------------------
procedure CheckNode(Node: TTreeNode; Checked:boolean);
begin
  if Assigned(Node) then
    if Checked then
      Node.StateIndex := ImgIndexChecked
    else
      Node.StateIndex := ImgIndexUnchecked;
end;

// -------------------------------------------------------------------------------------------    N
procedure ToggleTreeViewCheckBoxes(Node: TTreeNode);
begin
  if Assigned(Node) then begin
    if Node.StateIndex = ImgIndexUnchecked then
      Node.StateIndex := ImgIndexChecked
    else
    if Node.StateIndex = ImgIndexChecked then
      Node.StateIndex := ImgIndexUnchecked
  end;
end;

// -------------------------------------------------------------------------------------------     N
function NodeChecked(ANode:TTreeNode): Boolean;
begin
  result := (ANode.StateIndex = ImgIndexChecked);
end;

// -------------------------------------------------------------------------------------------
procedure Tfrm_Menu_Contas.CTV_MenuSelectionChanged(Sender: TObject);
begin
  if (Sender is TTreeView) and assigned(TTreeView(Sender).Selected) then // <---- check that a node is selected
   begin
    if  (TTreeView(Sender).Selected.Text = 'Trata Ficheiros CSV  -  CGD')
      then
      begin
// removed        frm_trata_ficheiro_CGD_csv.show;

        E_Last_Selection.Text := 'Trata Ficheiros CSV  -  CGD';
        TTreeView(Sender).Selected.Selected := False;
      end
    else if (TTreeView(Sender).Selected.Text = 'Trata Ficheiros CSV  -  NB')
     then
     begin
// removed      frm_trata_ficheiro_NB_csv.show;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
     end
    else if (TTreeView(Sender).Selected.Text = 'Prepara a Base de Dados  -  CGD')
      then
      begin
// removed        frm_prepara_cgd_base_dados.show;
        M_Acerca.Visible := FALSE;

        E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
        TTreeView(Sender).Selected.Selected := False;
      end
//    else if (TTreeView(Sender).Selected.Text = 'Prepara a Base de Dados  -  NB')
      else if (TTreeView(Sender).Selected.Text = 'das contas  (base e reserva)')
      then
      begin
//removed   frm_prepara_nb_base_dados.show;
        M_Acerca.Visible := FALSE;

        E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
        TTreeView(Sender).Selected.Selected := False;
      end
      else if (TTreeView(Sender).Selected.Text = 'dos cartões de crédito')
      then
      begin
        showmessage('linha 90 - em desenvolvimento');
//        frm_prepara_cc_nb_base_dados.show;
        M_Acerca.Visible := FALSE;

        E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
        TTreeView(Sender).Selected.Selected := False;
      end

    else if (TTreeView(Sender).Selected.Text = 'Edita Movimentos  -  CGD')
      then
      begin
        frm_dm_movimentos.SQLQ_Movimentos_CGD.Active := FALSE;
        frm_dm_movimentos.SQLQ_Movimentos_CGD.SQL.Text := 'select * from sch_conta.movimentos_cgd order by data_mov ASC';
        frm_dm_movimentos.SQLQ_Movimentos_CGD.Active := TRUE;

       if frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active = FALSE then
          frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active := TRUE;

        frm_edita_cgd_movimentos.show;
        M_Acerca.Visible := FALSE;

        E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
        TTreeView(Sender).Selected.Selected := False;
      end
    else if (TTreeView(Sender).Selected.Text = 'de contas (base e reserva)')
      then
      begin
        frm_dm_movimentos.SQLQ_Movimentos_NB.Active := FALSE;
        frm_dm_movimentos.SQLQ_Movimentos_NB.SQL.Text := 'select * from sch_conta.movimentos_nb order by data_oper ASC';
        frm_dm_movimentos.SQLQ_Movimentos_NB.Active := TRUE;

        if frm_dm_movimentos.SQLQ_total_movimentos_NB.Active = FALSE then
          frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := TRUE;

//        frm_edita_nb_movimentos.show;
        M_Acerca.Visible := FALSE;

        E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
        TTreeView(Sender).Selected.Selected := False;
      end

    else if (TTreeView(Sender).Selected.Text = 'de cartões de crédito')
      then
      begin
        showmessage('linha 135 - em desenvolvimento');
//        frm_dm_movimentos.SQLQ_Movimentos_NB.Active := FALSE;
//        frm_dm_movimentos.SQLQ_Movimentos_NB.SQL.Text := 'select * from sch_conta.movimentos_nb order by data_oper ASC';
//        frm_dm_movimentos.SQLQ_Movimentos_NB.Active := TRUE;

//        if frm_dm_movimentos.SQLQ_total_movimentos_NB.Active = FALSE then
//          frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := TRUE;

        frm_edita_cc_nb_movimentos.show;
        M_Acerca.Visible := FALSE;

        E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
        TTreeView(Sender).Selected.Selected := False;
      end

    else if (TTreeView(Sender).Selected.Text = 'Edita Facturas')
     then
     begin
       frm_dm_movimentos.SQLQ_Facturas.Active := FALSE;
       frm_dm_movimentos.SQLQ_Facturas.SQL.Text := 'select * from sch_conta.facturas order by pk_facturas asc';
       frm_dm_movimentos.SQLQ_Facturas.Active := TRUE;

       frm_edita_facturas.Show;
       M_Acerca.Visible := FALSE;

       E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
       TTreeView(Sender).Selected.Selected := False;
     end
    else if (TTreeView(Sender).Selected.Text = 'Tipos de Despesa')
      then
      begin
       // removed        frm_tipos_despesa.Show;

        E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
        TTreeView(Sender).Selected.Selected := False;
      end
    else if (TTreeView(Sender).Selected.Text = 'Tipos de Movimento')
      then
      begin
       // removed        frm_tipos_movimento.Show;
        M_Acerca.Visible := FALSE;

        E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
        TTreeView(Sender).Selected.Selected := False;
      end
    else if (TTreeView(Sender).Selected.Text = 'Informação')
      then
      begin
        M_Acerca.Visible := TRUE;

        E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
        TTreeView(Sender).Selected.Selected := False;
      end
    else if (TTreeView(Sender).Selected.Text = 'Exit')
      then
      begin
        Application.Terminate;
      end;
  TV_Menu_Build := FALSE;
  end

end;

// -------------------------------------------------------------------------------------------
procedure Tfrm_Menu_Contas.FormActivate(Sender: TObject);
var
  pnode, node, opcao: TTreeNode;
  i: integer;
  CurrentNode : TTreenode;
begin
  TV_Menu.Top := 25;
  TV_Menu.Left := 900;
  TV_Menu.Height := 600;
  TV_Menu.Width := 450;

  if Ja_Criou = 0 then
  begin
    with TV_Menu.Items do
    begin
      node := Add(nil, 'Contas bancárias e registo de facturas');

//      CurrentNode := GetNodeByText(TV_Menu, 'Contas bancárias e registo de facturas');
//      CurrentNode.SelectedIndex := 1;

//      node.ImageIndex := 1;

//      node.ImageIndex := 0;
//      node.SelectedIndex := 0;
      CheckNode(node, FALSE);
//=======================================

      pnode := Add(nil, 'Tratamento dos Ficheiros CSV');
//      pnode.ImageIndex := 2;
//      pnode.SelectedIndex := 2;
//      CheckNode(pnode, false);
      CheckNode(pnode, false);

      node := AddChild(pnode, 'Trata Ficheiros CSV  -  CGD');

      node := AddChild(pnode, 'Trata Ficheiros CSV  -  NB');
//=======================================

      pnode := Add(nil, 'Preparação das Bases de Dados');
      AddChild(pnode, 'Prepara a Base de Dados  -  CGD');
      CheckNode(pnode, false);

      AddChild(pnode, 'Prepara a Base de Dados  -  NB');
      pnode.HasChildren := TRUE;
      pnode.Selected := TRUE;

{
    for I := 0 to TV_Menu.Items.Count - 1 do       // http://www.delphigroups.info/2/12/325357.html
    begin
//      showmessage(TV_Menu.Items[i].Text + '  --1111--  ' + inttostr(I) + ' ---- ' + 'Index:  ' + inttostr(node.SelectedIndex));
      TV_Menu.Items[i].Selected := True;
      TV_Menu.Refresh;
      checknode(pnode, false);
    end;
}

      CurrentNode := GetNodeByText(TV_Menu, 'Prepara a Base de Dados  -  NB');

      node := AddChild(CurrentNode, 'das contas  (base e reserva)');

      CurrentNode := GetNodeByText(TV_Menu, 'Prepara a Base de Dados  -  NB');

      node := AddChild(CurrentNode, 'dos cartões de crédito');
//=======================================

      pnode := Add(nil, 'Edita Movimentos');
//      pnode.ImageIndex := -1;
//      pnode.SelectedIndex := 2;
//      CheckNode(pnode, false);
//      node := AddChild(pnode, 'Prepara a Base de Dados  -  CGD');
      AddChild(pnode, 'Edita Movimentos  -  CGD');
      CheckNode(pnode, false);


      AddChild(pnode, 'Edita Movimentos  -  NB');                   //
      pnode.HasChildren := TRUE;
      pnode.Selected := TRUE;

      CurrentNode := GetNodeByText(TV_Menu, 'Edita Movimentos  -  NB');
{
    for I := 0 to TV_Menu.Items.Count - 1 do       // http://www.delphigroups.info/2/12/325357.html
    begin
//      showmessage(TV_Menu.Items[i].Text + '  --1111--  ' + inttostr(I) + ' ---- ' + 'Index:  ' + inttostr(node.SelectedIndex));
      TV_Menu.Items[i].Selected := True;
      TV_Menu.Refresh;
      checknode(pnode, false);
    end;
}

//      node := AddChild(pnode, 'das contas  (base e reserva)');
      node := AddChild(CurrentNode, 'de contas (base e reserva)');
//      node.ImageIndex := 0;
//      node.SelectedIndex := 3;
//      checknode(pnode, false);
      node := AddChild(CurrentNode, 'de cartões de crédito');
//=======================================

      pnode := Add(nil, 'Edita Facturas');
//      pnode.ImageIndex := -1;
//      pnode.SelectedIndex := 2;
//      CheckNode(pnode, false);
//=======================================

      pnode := Add(nil, 'Tabelas Auxiliares');

      AddChild(pnode, 'Movimentos');
      pnode.HasChildren := TRUE;
      pnode.Selected := TRUE;

      CurrentNode := GetNodeByText(TV_Menu, 'Movimentos');

      node := AddChild(CurrentNode, 'Tipos de Despesa');
      node := AddChild(CurrentNode, 'Tipos de Movimento');
//      node.ImageIndex := 0;
//      node.SelectedIndex := 4;
//      checknode(pnode, false);
//=======================================

      AddChild(pnode, 'Facturas');
//      pnode.ImageIndex := 0;
//      pnode.SelectedIndex := 0;
      CheckNode(pnode, false);
//=======================================

      pnode := Add(nil, 'Informação');
//      pnode.ImageIndex := -1;
//      pnode.SelectedIndex := 2;
//      CheckNode(pnode, false);
//      node := AddChild(pnode, 'Prepara a Base de Dados  -  CGD');
//=======================================

      pnode := Add(nil, 'Exit');
//      pnode.ImageIndex := -1;
//      pnode.SelectedIndex := 2;
//      CheckNode(pnode, false);
//      node := AddChild(pnode, 'Prepara a Base de Dados  -  CGD');

      TV_Menu.ShowButtons := TRUE;
      TV_Menu.SetFocus;

      CurrentNode := GetNodeByText(TV_Menu, 'Contas bancárias e registo de facturas');
      CurrentNode.Selected := TRUE;
//      TV_Menu.Refresh;
//      Node.MakeVisible;


//=======================================
//***    TV_Menu.Refresh;

//=======================================

{
    node := Add(nil, 'Item1  0 - 0');
    node.ImageIndex := 0;
    node.SelectedIndex := 0;
    CheckNode(node, true);

    node := Add(nil, 'Item2  1 - 1');
    node.ImageIndex := 1;
    node.SelectedIndex := 1;
    CheckNode(node, false);

    pnode := Add(nil, 'Item3  2 - 2');
    pnode.ImageIndex := 2;
    pnode.SelectedIndex := 2;
    CheckNode(pnode, false);
    node := AddChild(pnode, 'Child1  5 - 5');
    node.ImageIndex := 5;
    node.SelectedIndex := 5;
    AddChild(pnode, 'Child2    sem IDX');

    pnode := Add(nil, 'Item4   sem IDX');
    node := AddChild(pnode, 'Child3  3 - 3');
    node.ImageIndex := 3;
    node.SelectedIndex := 3;
    CheckNode(node, false);
    node := AddChild(pnode, 'Child4  sem IDX');
    CheckNode(node, false);
}

    TV_Menu.FullExpand;           // TV_Menu.FullCollapse;
//    TV_Menu.Refresh;

    end;
    Ja_Criou := 1;       // para evitar que seja repetida a criação dos itens do menu
  end;





//  CTV_Menu.OwnerDraw := TRUE;
  Screen.MenuFont.Name := 'Arial Black';
  Screen.MenuFont.Size := 12;
  Screen.MenuFont.Style := [fsBold];

  Top := 100;
  Left := 100;
  Height := 900;
  Width := 1700;

  TV_Menu.Top := 25;
  TV_Menu.Left := 30;
  TV_Menu.Width := 450;
  TV_Menu.Height := 600;

  M_Acerca.Top := 25;
  M_Acerca.Left := TV_Menu.Left + TV_Menu.Width + 100;
  M_Acerca.Height := 300;
  M_Acerca.Width := 750;

  L_Last_Selection.Left := TV_Menu.Left;
  E_Last_Selection.Left := L_Last_Selection.Left + L_Last_Selection.Width + 10;
  L_Last_Selection.Top := TV_Menu.Top + TV_Menu.Height + 20;
  E_Last_Selection.Top := L_Last_Selection.Top;
  E_Last_Selection.Width := 248;
end;

// -------------------------------------------------------------------------------------------
procedure Tfrm_Menu_Contas.CTV_MenuClick(Sender: TObject);
var
  P: TPoint;
  node: TTreeNode;
  ht: THitTests;
begin
  GetCursorPos(P);
  P := TV_Menu.ScreenToClient(P);
  ht := TV_Menu.GetHitTestInfoAt(P.X, P.Y);
  if (htOnStateIcon in ht) then begin
    node := TV_Menu.GetNodeAt(P.X, P.Y);
    ToggleTreeViewCheckBoxes(node);
  end;
end;

// -------------------------------------------------------------------------------------------
procedure Tfrm_Menu_Contas.M_AcercaClick(Sender: TObject);
begin
  M_Acerca.Visible := FALSE;
end;

// -------------------------------------------------------------------------------------------
procedure Tfrm_Menu_Contas.TV_MenuClick(Sender: TObject);
var
  P: TPoint;
  node: TTreeNode;
  ht: THitTests;
begin
  GetCursorPos(P);
  P := TV_Menu.ScreenToClient(P);
  ht := TV_Menu.GetHitTestInfoAt(P.X, P.Y);
  if (htOnStateIcon in ht) then
  begin
    node := TV_Menu.GetNodeAt(P.X, P.Y);
    ToggleTreeViewCheckBoxes(node);
  end;

  TV_Menu_Build := TRUE;
end;

// -------------------------------------------------------------------------------------------
procedure Tfrm_Menu_Contas.TV_MenuSelectionChanged(Sender: TObject);
begin
//  showmessage('passou');

  if (Sender is TTreeView) and assigned(TTreeView(Sender).Selected) and (TV_Menu_Build = TRUE) then // <---- check that a node is selected
  begin
    if  (TTreeView(Sender).Selected.Text = 'Trata Ficheiros CSV  -  CGD')
    then
    begin
      // removed      frm_trata_ficheiro_CGD_csv.show;
      E_Last_Selection.Text := 'Trata Ficheiros CSV  -  CGD';

      TTreeView(Sender).Selected.Selected := False;
    end
    else if (TTreeView(Sender).Selected.Text = 'Trata Ficheiros CSV  -  NB')
    then
    begin
      // removed      frm_trata_ficheiro_NB_csv.show;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
    end
    else if (TTreeView(Sender).Selected.Text = 'Prepara a Base de Dados  -  CGD')
    then
    begin
      // removed      frm_prepara_cgd_base_dados.show;
      M_Acerca.Visible := FALSE;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
    end
//    else if (TTreeView(Sender).Selected.Text = 'Prepara a Base de Dados  -  NB')
    else if (TTreeView(Sender).Selected.Text = 'das contas  (base e reserva)')
    then
    begin
      // removed      frm_prepara_nb_base_dados.show;
      M_Acerca.Visible := FALSE;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
    end
    else if (TTreeView(Sender).Selected.Text = 'dos cartões de crédito')
    then
    begin
      showmessage('linha 620 - em desenvolvimento');
//        frm_prepara_cc_nb_base_dados.show;
      M_Acerca.Visible := FALSE;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
    end

    else if (TTreeView(Sender).Selected.Text = 'Edita Movimentos  -  CGD')
    then
    begin
      frm_dm_movimentos.SQLQ_Movimentos_CGD.Active := FALSE;
      frm_dm_movimentos.SQLQ_Movimentos_CGD.SQL.Text := 'select * from sch_conta.movimentos_cgd order by data_mov ASC';
      frm_dm_movimentos.SQLQ_Movimentos_CGD.Active := TRUE;

      if frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active = FALSE then
         frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active := TRUE;

      frm_edita_cgd_movimentos.show;
      M_Acerca.Visible := FALSE;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
    end
    else if (TTreeView(Sender).Selected.Text = 'de contas (base e reserva)')
    then
    begin
      frm_dm_movimentos.SQLQ_Movimentos_NB.Active := FALSE;
      frm_dm_movimentos.SQLQ_Movimentos_NB.SQL.Text := 'select * from sch_conta.movimentos_nb order by data_oper ASC';
      frm_dm_movimentos.SQLQ_Movimentos_NB.Active := TRUE;

      if frm_dm_movimentos.SQLQ_total_movimentos_NB.Active = FALSE then
         frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := TRUE;

//      frm_edita_nb_movimentos.show;
      M_Acerca.Visible := FALSE;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
    end

    else if (TTreeView(Sender).Selected.Text = 'de cartões de crédito')
    then
    begin

  //        frm_dm_movimentos.SQLQ_Movimentos_NB.Active := FALSE;
  //        frm_dm_movimentos.SQLQ_Movimentos_NB.SQL.Text := 'select * from sch_conta.movimentos_nb order by data_oper ASC';
  //        frm_dm_movimentos.SQLQ_Movimentos_NB.Active := TRUE;

  //        if frm_dm_movimentos.SQLQ_total_movimentos_NB.Active = FALSE then
  //          frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := TRUE;

      frm_edita_cc_nb_movimentos.show;
      M_Acerca.Visible := FALSE;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
    end

    else if (TTreeView(Sender).Selected.Text = 'Edita Facturas')
    then
    begin
      frm_dm_movimentos.SQLQ_Facturas.Active := FALSE;
      frm_dm_movimentos.SQLQ_Facturas.SQL.Text := 'select * from sch_conta.facturas order by pk_facturas asc';
      frm_dm_movimentos.SQLQ_Facturas.Active := TRUE;

      frm_edita_facturas.Show;
      M_Acerca.Visible := FALSE;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
    end
    else if (TTreeView(Sender).Selected.Text = 'Tipos de Despesa')
    then
    begin
      // removed      frm_tipos_despesa.Show;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
    end
    else if (TTreeView(Sender).Selected.Text = 'Tipos de Movimento')
    then
    begin
      // removed      frm_tipos_movimento.Show;
      M_Acerca.Visible := FALSE;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
    end
    else if (TTreeView(Sender).Selected.Text = 'Informação')
    then
    begin
      M_Acerca.Visible := TRUE;

      E_Last_Selection.Text := TTreeView(Sender).Selected.Text;
      TTreeView(Sender).Selected.Selected := False;
    end
    else if (TTreeView(Sender).Selected.Text = 'Exit')
    then
    begin
      Application.Terminate;
    end;
  end;
    Ja_Criou := 1;               // para eveitar que o menu seja repetidamente e serialmente criado

end;

// -------------------------------------------------------------------------------------------




end.

